Redmine - Patch #39110

Replacing request_store with ActiveSupport::CurrentAttributes
2023-09-24 17:40 - Takashi Kato

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: 6.0.0

Description

Redmine utilizes the request_store gem to maintain a record of currently logged-in users.
However, Rails itself offers an additional feature called ActiveSupport::CurrentAttributes leveraging this module, we can eliminate the
reliance on request_store.

ActiveSupport::CurrentAttributes provides equivalent functionality to request_store, but its value is reset when an ActiveJob is
executed. To address this, a callback has been introduced to preserve the value when Activedob is employed.

I'm sharing this post because I'm currently running Redmine on a new Rails version, and after applying the following pull request,
"test/integration/sudo_mode_test.rb" began to fail in multiple instances.

Link to the pull request: https:/github.com/rails/rails/pull/47092

Related issues:
Related to Redmine - Feature #36320: Migrate to Rails 7.2 Closed

Associated revisions

Revision 22473 - 2023-11-21 07:45 - Marius BALTEANU
Replace request_store with ActiveSupport::CurrentAttributes (#39110).

Patch by Takashi Kato.

Revision 22474 - 2023-11-21 07:48 - Marius BALTEANU
Remove request_store gem (#39110).

Patch by Takashi Kato.

Revision 22494 - 2023-12-04 07:18 - Marius BALTEANU
Fix typo (#39110).

Patch by Mizuki ISHIKAWA.

History

#1 - 2023-11-20 01:24 - Marius BALTEANU
- Related to Feature #36320: Migrate to Rails 7.2 added

#2 - 2023-11-20 08:37 - Marius BALTEANU
- Category set to Code cleanup/refactoring
- Assignee set to Marius BALTEANU

- Target version set to 6.0.0

#3 - 2023-11-21 07:46 - Marius BALTEANU

- Status changed from New to Resolved
Patch committed, thanks!

#4 - 2023-11-26 15:21 - Marius BALTEANU

- Status changed from Resolved to Closed

2025-05-01 1/2



https://github.com/rails/rails/pull/29180.By
https://github.com/rails/rails/pull/47092

#5 - 2023-12-04 03:50 - Mizuki ISHIKAWA
Could you please correct the typo in r22473.

diff --git a/lib/redmine/sudo_mode.rb b/lib/redmine/sudo_mode.rb
index d73880937..8df6d48d7 100644

—-—— a/lib/redmine/sudo_mode.rb

+++ b/lib/redmine/sudo_mode.rb

@@ -225,7 +225,7 Q@ module Redmine

# Turn sudo mode back on
def self.enable!

= CurrentSUdoMode.disabled = nil
+ CurrentSudoMode.disabled = nil
end

def self.enabled?

#6 - 2023-12-04 07:18 - Marius BALTEANU
Mizuki ISHIKAWA wrote in #note-5:
Could you please correct the typo in r22473.
(-]

Thanks for pointing this out.

#7 - 2023-12-04 07:47 - Mizuki ISHIKAWA

Thank you for your prompt response.
